--------------------------------------------------------------------------------
-- Company: <Name>
--
-- File: freq_counter.vhd
-- File history:
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--      <Revision number>: <Date>: <Comments>
--
-- Description: 
--
-- <Description here>
--
-- Targeted device: <Family::PolarFire> <Die::MPF300T_ES> <Package::FCG1152>
-- Author: <Name>
--
--------------------------------------------------------------------------------

library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

entity freq_counter is
port (
    nReset   : in std_logic;
    clk      : in std_logic;
	enable   : in std_logic;
    cntr_rst : in std_logic;
    
    cntr     : out std_logic_vector(31 downto 0)
);
end freq_counter;

architecture architecture_freq_counter of freq_counter is

	signal cntr_i : std_logic_vector(31 downto 0);
    signal start_i : std_logic_vector(1 downto 0);

begin

    start_sync_P : process(clk, nReset)
    begin
        if(nReset = '0') then
            start_i <= (others => '0');
        elsif(clk'event and clk = '1') then
            start_i <= start_i(0) & enable;
        end if;
    end process start_sync_P;

    cntP : process(clk, nReset, cntr_rst)
    begin
        if(nReset = '0' or cntr_rst = '1') then
            cntr_i <= (others => '0');
        elsif(clk'event and clk = '1') then
            if(start_i(1) = '1') then
                cntr_i <= cntr_i + 1;
            end if;
        end if;
    end process cntP;

    cntr <= cntr_i;

end architecture_freq_counter;
